#include "autorunplugin.h"

LPVOID Adapter;

void SetAdapter(LPVOID aAdapter)
{
	Adapter = aAdapter;
}

int SetVar(LPWSTR AName, LPWSTR AValue, int AFlags)
{
  APIProc Proc = (APIProc)Adapter;

  VarInfo Info;
  Info.dwSize		= sizeof(VarInfo);
  Info.dwFlags		= AFlags;
  Info.lpName		= AName;
  Info.lpData		= AValue;
  Info.dwBufSize	= 0;

  return Proc(AU_PROC_SETVAR, &Info);
}

int GetVar(LPWSTR AVarName, LPWSTR lpBuffer, UINT nBufferSize)
{
  APIProc Proc = (APIProc)Adapter;

  VarInfo Info;
  Info.dwSize		= sizeof(VarInfo);
  Info.lpName		= AVarName;
  Info.lpData		= lpBuffer;
  Info.dwBufSize	= nBufferSize;

  return Proc(AU_PROC_GETVAR, &Info);
}

int SetVarMacro(LPWSTR AName, LPVOID AFuncAddr)
{
  APIProc Proc = (APIProc)Adapter;

  VarInfo Info;
  Info.dwSize		= sizeof(VarInfo);
  Info.dwFlags		= AU_VAR_MACRO;
  Info.lpName		= AName;
  Info.lpData		= AFuncAddr;
  Info.dwBufSize	= 0;

  return Proc(AU_PROC_SETVAR, &Info);
}

int AddFunc(LPWSTR AName, LPVOID AAddr, int AFlags)
{
  APIProc Proc = (APIProc)Adapter;

  PluginFuncInfo Info;
  Info.dwSize		= sizeof(PluginFuncInfo);
  Info.dwFlags		= AFlags;
  Info.lpFuncName	= AName;
  Info.lpFuncAddr	= AAddr;

  return Proc(AU_PROC_ADDFUNC, &Info);
}

int ParseNext(LPWSTR AParamStr, LPWSTR ABuffer, DWORD nBufSize)
{
  APIProc Proc = (APIProc)Adapter;

  ParseNextData Data;
  Data.lpText		= AParamStr;
  Data.lpBuffer		= ABuffer;
  Data.dwBufSize	= nBufSize;

  return Proc(AU_PROC_PARSER_NEXT, &Data);
}

int ExpandVars(LPWSTR AText, LPWSTR ABuffer, DWORD nBufSize)
{
  APIProc Proc = (APIProc)Adapter;

  ExpVars Data;
  Data.lpText		= AText;
  Data.lpBuffer		= ABuffer;
  Data.dwBufSize	= nBufSize;

  return Proc(AU_PROC_EXPANDVARS, &Data);
}

int ReportError(INT MsgID, LPCWSTR aParam)
{
  APIProc Proc = (APIProc)Adapter;

  ErrorReport Data;
  Data.dwSize   = sizeof(ErrorReport);
  Data.nMsgID   = MsgID;
  Data.lpText   = aParam;
  Data.nFlags   = 0;

  return Proc(AU_PROC_REPORTERROR, &Data);
}

int ReportError(LPCWSTR aText)
{
	return ReportError(AU_ERR_USERMSG, aText);
}

int CallCommand(LPWSTR ACmdLine, LPWSTR AResult, DWORD nResultSize)
{
	APIProc Proc = (APIProc)Adapter;

	CallCmd Data;
	Data.lpText = ACmdLine;
	Data.lpBuffer = AResult;
	Data.dwBufSize = nResultSize;

	return Proc(AU_PROC_CALLCOMMAND, &Data);
}

int CallCommand(LPWSTR ACmdLine)
{
	APIProc Proc = (APIProc)Adapter;

	CallCmd Data;
	Data.lpText = ACmdLine;
	Data.lpBuffer = NULL;
	Data.dwBufSize = 0;

	return Proc(AU_PROC_CALLCOMMAND, &Data);
}

int GetAutorunValue(DWORD AValueType, LPCWSTR AValueName, LPVOID ABuffer, DWORD nBufSize, DWORD AFlags)
{
	APIProc Proc = (APIProc)Adapter;

	ValueInfo Data;
	Data.dwBufSize = sizeof(ValueInfo);
	Data.dwValueType = AValueType;
	Data.lpName = AValueName;
	Data.dwFlags = AFlags;
	Data.lpData = ABuffer;
	Data.dwBufSize = nBufSize;

	return Proc(AU_PROC_GETVALUE, &Data);
}